Subject: Re: bug#65414: save-some-buffers-functions are unexpectedly called when save-some-buffers pred is non-nil

From: Juri Linkov <[email-masked]>
Date: Sun, 03 Sep 2023 20:22:56 +0300

>> > In any case, not calling save-some-buffers-functions when PRED is
>> > non-nil is not something we can do, as that would be an incompatible
>> > behavior change.  We could perhaps add PRED to the arguments with
>> > which save-some-buffers-functions are called, as an optional argument.
>> > Would that be satisfactory?
>>
>> Yes, that would solve the interference between Magit and hyperdrive.el.
>>
>> See patch.
>
> Hmm... but how to make this change backward-compatible?  I mean, if
> there's some function out there that is used in
> save-some-buffers-functions, and it was written to accept only 2
> arguments, we cannot safely call it with 3 arguments, can we?

If nothing else helps, just catch 'wrong-number-of-arguments',
then call with an obsolete signature again.